//	+---------------------------+
//	|	Tombstone Mod			|
//	+---------------------------+
//	|	Version: 2.0			|
//	|	Released: October 6		|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

//	exec("Add-Ons/Server_Tombstones/server.cs");

//	RTB Prefs
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
	{
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	}
	RTB_registerPref("Place Tombstone on Death", "Tombstone Mod", "Pref::Tombstones::Place", "bool", "Server_Tombstones", 1, 0, 0);
	RTB_registerPref("Max Per Client", "Tombstone Mod", "Pref::Tombstones::MaxPerClient", "int -1 10", "Server_Tombstones", 5, 0, 0);
	RTB_registerPref("Allow Floating Tombstones", "Tombstone Mod", "Pref::Tombstones::AllowFloating", "bool","Server_Tombstones", 0, 0, 0);
	RTB_registerPref("Tombstone Collision", "Tombstone Mod", "Pref::Tombstones::SpawnWithCollision", "bool","Server_Tombstones", 1, 0, 0, "Tombstones_onUpdateCollision");
	RTB_registerPref("Custom Death Engravings", "Tombstone Mod", "Pref::Tombstones::DeathEngravings", "bool","Server_Tombstones", 1, 0, 0);
	RTB_registerPref("Delete After One Minute", "Tombstone Mod", "Pref::Tombstones::DeleteAfterMinute", "bool","Server_Tombstones", 0, 0, 0, "Tombstones_onUpdateMinuteDelete");
}
else
{
	$Pref::Tombstones::Place = true;
	$Pref::Tombstones::MaxPerClient = 5;
	$Pref::Tombstones::AllowFloating = false;
	$Pref::Tombstones::SpawnWithCollision = true;
	$Pref::Tombstones::DeathEngravings = true;
	$Pref::Tombstones::DeleteAfterMinute = false;
}

function Tombstones_GetDeathMessage(%client, %player, %killer, %damageType)
{
	if(!$Pref::Tombstones::DeathEngravings)
	{
		return;
	}
	%fileName[2] = "suicide";
	%fileName[5] = "momentum";
	%fileName[6] = "falling";
	%fileName[7] = "vehicle";
	if(isFile("Add-Ons/Server_Tombstones/data/" @ %fileName[%damageType] @ ".tomb"))
	{
		%fileName = %fileName[%damageType];
	}
	else
	{
		%fileName = "generic";
	}
	%fileData = "Add-Ons/Server_Tombstones/data/" @ %fileName @ ".tomb";
	if(!isObject(%killer) || %killer.name $= "" || %killer == %client)
	{
		%killType = "NOKILLER";
	}
	else
	{
		%killType = "KILLER";
	}
	%file = new fileObject();
	%file.openForRead(%fileData);
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		if(getField(%line, 0) $= %killType && getField(%line, 1) !$= "")
		{
			%lineData[%lineCount++] = strReplace(getField(%line, 1), "<KILLERNAME>", %killer.name);
		}
	}
	%file.close();
	%file.delete();
	return %lineData[getRandom(1, %lineCount)];
}

function Tombstones_onUpdateCollision(%old, %new)
{
	for(%a = 0; %a < BrickGroup_666.getCount(); %a++)
	{
		%this = BrickGroup_666.getObject(%a);
		%this.setColliding(%new);
	}
}

function Tombstones_onUpdateMinuteDelete(%old, %new)
{
	for(%a = 0; %a < BrickGroup_666.getCount(); %a++)
	{
		%this = BrickGroup_666.getObject(%a);
		if(%new == false)
		{
			cancel(%this.deleteSchedule);
		}
		else if(%new == true)
		{
			%this.deleteSchedule = %this.schedule(60000, delete);
		}
	}
}

function Tombstones_Place(%client, %player, %killer, %damageType)
{
	if(!$Pref::Tombstones::Place)
	{
		return;
	}
	if(!isObject(%killer) || %killer.name $= "")
	{
		%killer = "";
	}
	%max = $Pref::Tombstones::MaxPerClient;
	if(%client.tombStoneCount == 0)
	{
		%client.tombStoneCount = "0";
		// So it's the integer instead of an empty string
	}
	if(%client.tombStoneCount >= %max)
	{
		%deleteUs = %client.tombStoneCount - %max;
		for(%a = 0; %a <= %deleteUs; %a++)
		{
			if(isObject(%obj = %client.tombStone[%a]))
			{
				%obj.delete();
			}
		}
		for(%a = 0; %a < %max; %a++)
		{
			%next = %a + %deleteUs;
			%client.tombStone[%a] = %client.tombStone[%next];
		}
		%client.tombStone[%max] = "";
		%client.tombStoneCount -= %deleteUs;
	}
	if(%max == 0)
	{
		return;
	}
	%time = getSubStr(getWord(getDateTime(), 1), 0, strLen(getWord(getDateTime(), 1)) - 3);
	%hour = getSubStr(getWord(getDateTime(), 1), 0, strLen(getWord(getDateTime(), 1)) - 6);
	%minutes = getSubStr(getWord(getDateTime(), 1), strLen(getWord(getDateTime(), 1)) - 5, strLen(getWord(getDateTime(), 1)) - 6);
	if(%hour > 12)
	{
		%hour -= 12;
		%time = %hour @ ":" @ %minutes SPC "PM";
	}
	else
	{
		%time = %hour @ ":" @ %minutes SPC "AM";
	}
	%msg = "<color:ffffff>Here lies" SPC %client.name @ ".<br>Died on" SPC getWord(getDateTime(), 0) SPC "at" SPC %time @ ".";
	%msgrandom = getRandom(0, 4);
	%msgrandomtwo = getRandom(0, 6);
	%msg = %msg @ "<br>" @ Tombstones_GetDeathMessage(%client, %player, %killer, %damageType);
	switch(getRandom(0, 3))
	{
		case 0:
			%rotation = "1 0 0 0";
			
		case 1:
			%rotation = "0 0 -1 90";
			
		case 2:
			%rotation = "0 0 1 90";
			
		case 3:
			%rotation = "0 0 1 180";
	}
	
	%raycast = containerRaycast(%player.getworldboxcenter(), VectorAdd(%player.getworldboxcenter(), "0 0 -400"), $TypeMasks::TerrainObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::StaticShapeObjectType, %player);
	
	if($Pref::Tombstones::AllowFloating)
	{
		%position = %player.getPosition();
	}
	else
	{
		%position = posFromRaycast(%raycast);
	}
	
	%this = new fxDTSBrick()
	{
		datablock = brickGraveStoneData;
		position = vectorAdd(%position, "0 0" SPC brickGraveStoneData.bricksizeZ / 10);
		colorID = getRandom(5, 6);
		client = Tombstones;
		isTombstone = true;
		tombStoneMessage = %msg;
		rotation = %rotation;
		isPlanted = $Pref::Tombstones::AllowFloating;
	};
	if(!$Pref::Tombstones::SpawnWithCollision)
	{
		%this.setColliding(0);
		%this.setRaycasting(0);
	}
	BrickGroup_666.add(%this);
	%this.setTrusted(true);
	%this.plant();
	if(!%this.isPlanted)
	{
		%this.plantRaiseLoop = %this.schedule(0, plantRaiseRetry, %client);
	}
	else
	{
		%client.tombStone[%client.tombStoneCount] = %this;
		%client.tombStoneCount++;
		if($Pref::Tombstones::DeleteAfterMinute)
		{
			%this.deleteSchedule = %this.schedule(60000, delete);
		}
	}
	serverPlay3D(BrickChangeSound, %player.getPosition());
}

function fxDTSBrick::plantRaiseRetry(%this, %client)
{
	cancel(%this.plantRaiseLoop);
	if(%this.plantRaiseRetryCount >= 20)
	{
		messageClient(%client, 'MsgPlantError_Unstable', "\c3Your death point is too precarious, your tombstone was not created.");
		%this.delete();
		return;
	}
	%this.plantRaiseRetryCount++;
	%position = %this.position;
	%xy = getWords(%position, 0, 1);
	%z = getWord(%position, 2);
	%z += 0.2;
	%new = new fxDTSBrick(%this)
	{
		datablock = brickGraveStoneData;
		position = %xy SPC %z;
		colorID = %this.colorID;
		client = Tombstones;
		isTombstone = true;
		tombStoneMessage = %this.tombStoneMessage;
		rotation = %this.rotation;
		plantRaiseRetryCount = %this.plantRaiseRetryCount;
		
	};
	%plantRaiseRetryCount = %this.plantRaiseRetryCount;
	BrickGroup_666.add(%new);
	%new.setTrusted(true);
	%new.plant();
	%this.delete();
	if(!%new.isPlanted)
	{
		//%new.plantRaiseRetryCount = %plantRaiseRetryCount;
		%new.plantRaiseLoop = %new.schedule(0, plantRaiseRetry, %client);
	}
	else
	{
		%client.tombStone[%client.tombStoneCount] = %new;
		%client.tombStoneCount++;
		if($Pref::Tombstones::DeleteAfterMinute)
		{
			%this.deleteSchedule = %this.schedule(60000, delete);
		}
	}
}

function serverCmdClearAllTombstones(%client)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c0You are not admin.");
		return;
	}
	messageAll('MsgClearBricks', "\c3" @ %client.name SPC "\c0cleared all tombstones.");
	BrickGroup_666.chainDeleteAll();
}

if(isPackage(TombstonesMod))
{
	deactivatePackage(TombstonesMod);
}
package TombstonesMod
{
	function GameConnection::OnDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		Tombstones_Place(%client, %client.player, %killer, %damageType);
		parent::OnDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);
	}
	function fxDTSBrick::onPlant(%this)
	{
		parent::onPlant(%this);
		if(%this.isTombstone)
		{
			%this.eventOutput0 = "CenterPrint";
			%this.eventDelay0 = 0;
			%this.eventOutputParameter0_1 = %this.tombStoneMessage;
			%this.eventOutputParameter0_2 = 5;
			%this.eventInput0 = "onActivate";
			%this.eventOutputAppendClient0 = 1;
			%this.eventEnabled0 = 1;
			%this.eventTarget0 = "Client";
			%this.implicitCancelEvents = 0;
			%this.eventInputIdx0 = 0;
			%this.numEvents = 1;
			%this.eventOutputIdx0 = 0;
			%this.eventTargetIdx0 = 2;
		}
	}
	function fxDTSBrick::delete(%this)
	{
		if(%this.isTombstone)
		{
			%this.spawnExplosion(49, "1 1 1");
		}
		Parent::delete(%this);
	}
};

activatePackage(TombstonesMod);

function Tombstones_Init()
{
	echo("Initializing Tombstone Mod.");
	if(!isObject(BrickGroup_666))
	{
		new SimGroup(BrickGroup_666)
		{
			name = "Tombstone Group";
			bl_id = 666;
			client = Tombstones;
		};
		new GameConnection(Tombstones)
		{
			name = "Tombstone Group";
			bl_id = 666;
			isAdmin = 1;
			isSuperAdmin = 1;
	
		};
	}
	MainBrickGroup.add(BrickGroup_666);
	echo("Tombstone Mod initialized.");
}

//MainBrickGroup hasn't been created yet, so let's wait a few seconds!
schedule(2000, 0, Tombstones_Init);